# 
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


"""Klasa odczytujca zawarto plikw kedu.

	Kedu jest formatem plikw wywodzcym si SGML, 
	w ktrym Patnik przechowuje swoje dane.
	Klasa ta odczytuje taki plik i zwraca przetworzone dokumenty."""

from sgmllib import SGMLParser
import re

class KEDUParser(SGMLParser):
	"""Klasa odczytujca zawarto plikw kedu.

	Kedu jest formatem plikw wywodzcym si SGML, 
	w ktrym Patnik przechowuje swoje dane.
	Klasa ta odczytuje taki plik i zwraca przetworzone dokumenty."""

	def __init__(self, plik, lista_tmpl):
		SGMLParser.__init__(self)

		self.plik = plik
		self.dane = ''
		self.zusxxx = None
		self.lista_tmpl = lista_tmpl
		self.dokumenty = []


	def unknown_starttag(self, tag, attributes):
		self.dane = ''
		if not self.zusxxx:
			if tag in self.lista_tmpl:
				self.zusxxx = tag
				self.sekcje = []
	
	def unknown_endtag(self, tag):
		if tag == self.zusxxx:
			self.zusxxx = None
			self.dokumenty.append((tag, self.sekcje))
		if self.zusxxx and self.dane:
			self.sekcje.append((tag, self.dane))
		self.dane = ''

	def handle_data(self, data):
		self.dane += re.sub("[\t\r\n]+", "", data)
	
	def go(self):
		infile = open(self.plik, "r")
		for line in infile.readlines():
			self.feed(line)
		self.close()
		infile.close()
		return self.dokumenty
	


