#!/usr/bin/env python
# 
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

"""Eksport plikw kxml do formatu kedu.

	Modu umoliwia eksport danych z formatu Janosika
	do formatu Patnika."""

import KXML
import misc
import sys
import os.path
import string
from types import *


def eksportuj_pola(pola, outfile):
	wynik = ""
	zusxxx = "ZUS" + string.upper(pola[1]['name'])
	wynik += "<" + zusxxx + ".DP>\n"
	wynik += """<naglowek.DP>
                                                   
        
        
        
                        
        
                        
                        
        
                        
                        
 
 
                                
</naglowek.DP>\n"""
	wynik += "<" + zusxxx + ">\n"
	for section in filter(lambda e: type(e) is TupleType, pola[2]):
		nazwa = string.upper(section[1]['name'])
		wynik += "<" + nazwa + ">\n"
		for pole in filter(lambda e: type(e) is TupleType, section[2]):
			wynik += pole[2][0] + "\n"
		wynik += "</" + nazwa + ">\n"
	wynik += "</" + zusxxx + ">\n"
	wynik += "<stopka.DP>\n</stopka.DP>\n"
	wynik += "</" + zusxxx + ".DP>\n"
	outfile.write(wynik)


def eksportuj(dir, outfile):
	if os.path.exists(dir) and not os.path.isdir(dir):
		raise IOError, 'Obiekt nie jest katalogiem: %s' % outfile
	if os.path.exists(outfile) and not os.path.isfile(outfile):
		raise IOError, 'Obiekt nie jest plikiem: %s' % outfile

	plik = open(outfile, "w")
	plik.write("""<!DOCTYPE KEDU PUBLIC '-//ZUS//DTD KEDU 1.2//PL'[
<!ENTITY wersja '001.200' >
<!ENTITY strona.kodowa 'ISO 8859-2' >]>
<KEDU>
<naglowek.KEDU>
                                                   
        
                        
                        
                                
</naglowek.KEDU>\n""")
	misc.walktree(dir, lambda file, p = plik: eksportuj_plik(file, p))
	plik.write("<stopka.KEDU>\n</stopka.KEDU>\n</KEDU>\n")

def eksportuj_plik(file, outfile):
	# TO TRZEBA KONIECZNIE ZMIENIC!!!!!!!!!!!!!!!!!!!!!
	if file.find("CVS") == -1:
		dokument = KXML.wczytaj(file)
		for pola in dokument[2]:
			eksportuj_pola(pola, outfile)

def uzycie(nazwa):
	print "Skadnia: %s katalog_wejsciowy plik_wyjsciowy" % nazwa


def main():
	if not len(sys.argv) == 3:
		uzycie(sys.argv[0])
		sys.exit(2)
	
	try:
		eksportuj(sys.argv[1], sys.argv[2])
	except IOError:
		uzycie(sys.argv[0])
		sys.exit(1)


if __name__ == "__main__":
	main()
