
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

"""Modu obsugujcy cae GUI stworzone w glade dla Gtk2.

	"""
try:
	import pygtk
	pygtk.require('2.0')
except ImportError:
	pass

try:
	import gtk
except ImportError:
	pass


import gobject
import gtk.glade
import API
import os.path


# gtk2 uywa utf-8, a my iso-8859-2

def koduj(string):
	return unicode(string, 'iso-8859-2').encode('utf-8')

def dekoduj(string):
	return unicode(string, 'utf-8').encode('iso-8859-2')



# Obsuga okien formularzy

def zapisz_pole(xml, pole):
	nazwa = API.nazwa(pole)
	widget = xml.get_widget(nazwa)
	if widget:
		type = gobject.type_name(widget)
		if type == 'GtkCheckButton':
			if widget.get_active():
				API.zmien_wartosc_pola(pole, 'X')
			else:
				API.zmien_wartosc_pola(pole, ' ')
		elif type == 'GtkEntry':
			API.zmien_wartosc_pola(pole, dekoduj(widget.get_text()))

def zapisz_wartosci(xml, dokument):
	for sekcja in API.lista_sekcji(dokument):
		for pole in API.lista_pol(sekcja):
			zapisz_pole(xml, pole)

def zakoncz(obiekt, xml, dokument, window, zapisz):
	if zapisz:
		zapisz_wartosci(xml, dokument)
#		API.weryfikuj(dokument)
		API.zapisz_dokument(dokument)
	window.destroy()

def wczytaj_okno(plik, okno):
	xml = gtk.glade.XML(plik, okno)
	return xml

def ustaw_pole(xml, pole):
	nazwa = API.nazwa(pole)
	widget = xml.get_widget(nazwa)
	if widget:
		type = gobject.type_name(widget)
		if type == 'GtkCheckButton':
			widget.set_active(API.wartosc_pola(pole) == 'X')
#			print nazwa, 'OK!!!'
		elif type == 'GtkEntry':
			widget.set_text(koduj(API.wartosc_pola(pole)))
#			print nazwa, 'OK!!!'
		else:
			print nazwa, type
	else:
		print nazwa, 'Brak!!!'

pola_w_liscie = {
	'docra': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('docra_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('docra_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING)],
	'docrba': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('docrba_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('docrba_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING)],
	'ddorca': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('ddorca_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('ddorca_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('ddorca_kod_tyt_ubez', 'Kod', gobject.TYPE_STRING)],
	'ddorza': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('ddorza_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('ddorza_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('ddorza_kod_tyt_ubez', 'Kod', gobject.TYPE_STRING)],
	'ddorsa': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('ddo_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('ddo_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('ddo_kod_tytulu', 'Kod', gobject.TYPE_STRING)],
	'ddorna': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('ddo_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('ddo_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('ddo_kod_tytulu', 'Kod', gobject.TYPE_STRING)],
	'ddourga': [('pozycja', 'Pozycja', gobject.TYPE_INT), ('ddourga_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('ddourga_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('ddourga_kod_tyt_ubez', 'Kod', gobject.TYPE_STRING)]
}

def ustaw_wartosci_w_kolumnach(model, iter, sekcja, opis):
	wartosci = map(lambda a: a[0], opis)
	if 'pozycja' in wartosci:
		model.set_value(iter, wartosci.index('pozycja') + 1, -1)
	for pole in API.lista_pol(sekcja):
		nazwa_pola = API.nazwa(pole)
		if nazwa_pola in wartosci:
			nowa = API.wartosc_pola(pole)
			model.set_value(iter, wartosci.index(nazwa_pola) + 1, koduj(nowa))
	
def ustaw_sekcje_wielokrotna(xml, sekcja):
	nazwa = API.nazwa(sekcja)
#	print 'Sekcja wielokrotna - %s' % nazwa
	lista = xml.get_widget('%s_lista' % nazwa)

	opis = pola_w_liscie[nazwa]
	model = lista.get_model()
	
	# Czy jest to pierwsza taka sekcja?
	if not model:
		arg = map(lambda a: a[2], opis)
		# Tu przechowuje odniesienie do dokumentu
		arg.insert(0, gobject.TYPE_PYOBJECT)
		model = gtk.ListStore(*arg)
		lista.set_model(model)
		renderer = gtk.CellRendererText()
		i = 1
		for kolumna in opis:
			column = gtk.TreeViewColumn(koduj(kolumna[1]), renderer, text=i)
			lista.append_column(column)
			i = i + 1
	
	iter = model.append()
	model.set_value(iter, 0, sekcja)

	ustaw_wartosci_w_kolumnach(model, iter, sekcja, opis)
#	wartosci = map(lambda a: a[0], opis)
#	if 'pozycja' in wartosci:
#		model.set_value(iter, wartosci.index('pozycja') + 1, -1)
#	for pole in API.lista_pol(sekcja):
#		nazwa_pola = API.nazwa(pole)
#		if nazwa_pola in wartosci:
#			nowa = API.wartosc_pola(pole)
#			model.set_value(iter, wartosci.index(nazwa_pola) + 1, koduj(nowa))
	
	

def zakoncz_sekcje(obiekt, xml_nowy, sekcja, window, zapisz):
	if zapisz:
		for pole in API.lista_pol(sekcja):
			zapisz_pole(xml_nowy, pole)
	window.destroy()

def edytuj_sekcje(button, xml, nazwa, dokument):
	# Znalezienie odpowiedniej sekcji
	lista = xml.get_widget('%s_lista' % nazwa)
	model, iter = lista.get_selection().get_selected()
	if not iter:
		return

	sekcja = model.get_value(iter, 0)

	# Wczytanie nowego okna...
	typ = API.typ_dokumentu(dokument)
	plik = os.path.join('gui/glade2', 'zus-%s-%s.glade' % (typ[3:], nazwa))
	okno = '%s_okno' % nazwa
	xml_nowy = wczytaj_okno(plik, okno)
	window = xml_nowy.get_widget(okno)
	ok = xml_nowy.get_widget('ok_button')
	anuluj = xml_nowy.get_widget('anuluj_button')
	window.connect('destroy', gtk.mainquit)
	anuluj.connect('clicked', zakoncz_sekcje, xml_nowy, sekcja, window, 0)
	ok.connect('clicked', zakoncz_sekcje, xml_nowy, sekcja, window, 1)

	# Ustawienie wartoci i odpalenie okna...
	for pole in API.lista_pol(sekcja):
		ustaw_pole(xml_nowy, pole)
	window.grab_add()
	gtk.mainloop()

	# Podczas edycji, mogy si zmieni wartoci pl,
	# ktre wywietlami w licie..
	opis = pola_w_liscie[API.nazwa(sekcja)]
	ustaw_wartosci_w_kolumnach(model, iter, sekcja, opis)


def dodaj_sekcje(button, xml, nazwa, dokument):
	lista = xml.get_widget('%s_lista' % nazwa)
	model = lista.get_model()
	sekcja = model.get_value(iter, 0)
	nowa = API.dodaj_sekcje(dokument, sekcja)
	ustaw_sekcje_wielokrotna(xml, nowa)

def usun_sekcje(button, xml, nazwa, dokument):
	lista = xml.get_widget('%s_lista' % nazwa)
	model, iter = lista.get_selection().get_selected()
	if not iter:
		return

	sekcja = model.get_value(iter, 0)
	model.remove(iter)
	nowa = API.usun_sekcje(dokument, sekcja)
	if nowa:
		ustaw_sekcje_wielokrotna(xml, nowa)

def ustaw_wartosci(xml, dokument):
	nazwa = ''
	for sekcja in API.lista_sekcji(dokument):
		wiel = API.atrybut(API.typ_dokumentu(dokument), 
				API.nazwa(sekcja), 'multiple')
		if wiel == 'TRUE':
			if API.nazwa(sekcja) != nazwa:
				nazwa = API.nazwa(sekcja)
				
				# Ustawienie sygnaw dla tej listy...
				edytuj = xml.get_widget('%s_edytuj_button' % nazwa)
				dodaj = xml.get_widget('%s_dodaj_button' % nazwa)
				usun = xml.get_widget('%s_usun_button' % nazwa)
				edytuj.connect('clicked', edytuj_sekcje, xml, nazwa, dokument)
				dodaj.connect('clicked', dodaj_sekcje, xml, nazwa, dokument)
				usun.connect('clicked', usun_sekcje, xml, nazwa, dokument)
				
			ustaw_sekcje_wielokrotna(xml, sekcja)
		else:
			for pole in API.lista_pol(sekcja):
				ustaw_pole(xml, pole)

def edytuj_dokument(dokument):
	typ = API.typ_dokumentu(dokument)
	plik = os.path.join('gui/glade2', 'zus-%s.glade' % typ[3:])
	okno = '%s_okno' % typ[3:]
	xml = wczytaj_okno(plik, okno)

	#ustawienie sygnaw
	print okno
	window = xml.get_widget(okno)
	ok = xml.get_widget('ok_button')
	anuluj = xml.get_widget('anuluj_button')
	window.connect('destroy', gtk.mainquit)
	anuluj.connect('clicked', zakoncz, xml, dokument, window, 0)
	ok.connect('clicked', zakoncz, xml, dokument, window, 1)

	ustaw_wartosci(xml, dokument)
	window.grab_add()
	gtk.mainloop()



def wypelnij_zestawy(selection, xml):
	model, iter = selection.get_selected()
	platnik = model.get_value(iter, 0)

	zestawy_tree = xml.get_widget('zestawy1_lista')
	model2 = zestawy_tree.get_model()
	model2.clear()
	for zestaw in API.lista_zestawow(platnik):
		iter2 = model2.append()
		model2.set_value(iter2, 0, zestaw)
		model2.set_value(iter2, 1, koduj(API.nazwa_zestawu(zestaw)))
	  

def wypelnij_firmy(xml):
	firmy_tree = xml.get_widget('folder_lista')
	usun_kolumny(firmy_tree)
	model = gtk.ListStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING)
	firmy_tree.set_model(model)
	renderer = gtk.CellRendererText()
	column = gtk.TreeViewColumn(koduj('Nazwa'), renderer, text=1)
	firmy_tree.append_column(column)
	for firma in API.lista_firm():
		iter = model.append()
		model.set_value(iter, 0, firma)
		model.set_value(iter, 1, koduj(API.nazwa_zestawu(firma)))
	selection = firmy_tree.get_selection()
	selection.connect('changed', wypelnij_zestawy, xml)
 
	zestawy_tree = xml.get_widget('zestawy1_lista')
	usun_kolumny(zestawy_tree)
	model2 = gtk.ListStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING)
	zestawy_tree.set_model(model2)
	renderer2 = gtk.CellRendererText()
	column2 = gtk.TreeViewColumn(koduj('Nazwa'), renderer2, text=1)
	zestawy_tree.append_column(column2)
	

def zakoncz_platnik(obiekt, window, zapisz, wynik_ok, xml):
	if zapisz:
		zestawy_tree = xml.get_widget('zestawy1_lista')
		model, iter = zestawy_tree.get_selection().get_selected()
		wynik_ok[:] = [model.get_value(iter, 0)]
	window.destroy()

def wybierz_platnika_i_zestaw():
	firmy = API.lista_firm()
	if len(firmy) == 0:
		return None

	plik = os.path.join('gui/glade2', 'zestaw.glade')
	okno = 'zestaw_okno'
	xml = wczytaj_okno(plik, okno)

	# Tu przekazuje wynik
	wynik_ok = []

	wypelnij_firmy(xml)

	window = xml.get_widget(okno)
	ok = xml.get_widget('ok_button')
	anuluj = xml.get_widget('anuluj_button')
	window.connect('destroy', gtk.mainquit)
	anuluj.connect('clicked', zakoncz_platnik, window, 0, wynik_ok, xml)
	ok.connect('clicked', zakoncz_platnik, window, 1, wynik_ok, xml)

	notebook = xml.get_widget('notebook1')
	notebook.set_show_tabs(0)

	window.grab_add()
	gtk.mainloop()

	return wynik_ok



# Obsuga okna gownego programu

def dodaj_dzieci(tree, parent, zestaw, podzestaw):
	podzestawy = API.lista_podzestawow(zestaw, podzestaw)
	model = tree.get_model()
	for podpod in podzestawy:
		iter = model.append(parent)
		model.set_value(iter, 0, '')
		model.set_value(iter, 1, koduj(API.nazwa_zestawu(podpod)))
		model.set_value(iter, 2, koduj(''))
		model.set_value(iter, 3, '')
		dodaj_dzieci(tree, iter, zestaw, podpod)
	dokumenty_typy = {}
	for dokument in API.lista_dokumentow(zestaw, podzestaw):
		nazwa = API.typ_dokumentu(dokument)
		if nazwa not in dokumenty_typy:
			dokumenty_typy[nazwa] = []
		dokumenty_typy[nazwa].append(dokument)
	for typ in dokumenty_typy:
		iter = model.append(parent)
		model.set_value(iter, 0, typ)
		model.set_value(iter, 1, koduj(typ))
		model.set_value(iter, 2, koduj('%d' % len(dokumenty_typy[typ])))
		model.set_value(iter, 3, dokumenty_typy[typ])

# lista pol w liscie - (nazwa_pola, nazwa_kolumny, typ_kolumny)
opis_dokumentu = {
	'platnik': [],
	'zuszpa': [],
	'zusdra': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('opls_data', 'Data', gobject.TYPE_STRING)],
	'zusrca': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('oplr_data', 'Data', gobject.TYPE_STRING)],
	'zusrna': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('oplr_data', 'Data', gobject.TYPE_STRING)],
	'zusrza': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('oplr_data', 'Data', gobject.TYPE_STRING)],
	'zusrsa': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('oplr_data', 'Data', gobject.TYPE_STRING)],
	'zusrga': [('pozycja', 'Id', gobject.TYPE_INT), ('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('oplr_data', 'Data', gobject.TYPE_STRING)],
	'zuszua': [('dau_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('dau_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('dau_pesel', 'Pesel', gobject.TYPE_STRING), ('dau_nip', 'NIP', gobject.TYPE_STRING), ('tyub_kod', 'Kod', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zusziua': [('adiu_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('adiu_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('adiu_pesel', 'Pesel', gobject.TYPE_STRING), ('adiu_nip', 'NIP', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszcna':  [('dau_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('dau_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('dau_pesel', 'Pesel', gobject.TYPE_STRING), ('dau_nip', 'NIP', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszcza':  [('dau_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('dau_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('dau_pesel', 'Pesel', gobject.TYPE_STRING), ('dau_nip', 'NIP', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszwua':  [('dau_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('dau_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('dau_pesel', 'Pesel', gobject.TYPE_STRING), ('dau_nip', 'Nip', gobject.TYPE_STRING), ('wubd_kod', 'Kod', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszza':  [('dau_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('dau_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('dau_pesel', 'Pesel', gobject.TYPE_STRING), ('dau_nip', 'NIP', gobject.TYPE_STRING), ('tyubz_kod', 'Kod', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszfa':  [('dipl_nazwa_skrocona', 'Nazwa skrcona', gobject.TYPE_STRING), ('dipl_nip', 'NIP', gobject.TYPE_STRING), ('dipl_regon', 'Regon', gobject.TYPE_STRING), ('dipl_pesel', 'Pesel', gobject.TYPE_STRING), ('opl2_data', 'Data', gobject.TYPE_STRING)],
	'zuszipa':  [('adip_nazwisko', 'Nazwisko', gobject.TYPE_STRING), ('adip_imie_pierwsze', 'Imi pierwsze', gobject.TYPE_STRING), ('adip_pesel', 'Pesel', gobject.TYPE_STRING), ('adip_nip', 'NIP', gobject.TYPE_STRING), ('opl1_data', 'Data', gobject.TYPE_STRING)],
	'zuszwpa':  [],
	'zuszba':  [],
	'zuszaa':  []
}

def dodaj_dokument(dokument_tree, pola_w_liscie, dok, poz):
	slownik = API.przygotuj_znajdz(dok)
	i = 1
	model = dokument_tree.get_model()
	iter = model.append()
	model.set_value(iter, 0, dok)
	for kol in pola_w_liscie:
		if kol[0] == 'pozycja':
			model.set_value(iter, i, poz + 1)
		elif kol[0] in slownik:
			pole = API.znajdz(slownik, kol[0])
			model.set_value(iter, i, koduj(API.wartosc_pola(pole[0])))
		i += 1

def edytuj_dokument_clicked(button, xml):
	dokument_tree = xml.get_widget('dokumenty_tree')
	model, iter = dokument_tree.get_selection().get_selected()
	dokument = model.get_value(iter, 0)
	edytuj_dokument(dokument)


def pobierz_nazwe_pliku(domyslna = ''):
	file_selection = gtk.FileSelection()
	file_selection.set_filename(domyslna)
	file_selection.run()
	nazwa = file_selection.get_filename()
	file_selection.destroy()
	return nazwa

def wyswietl_komunikat(komunikat):
	message_dialog = gtk.MessageDialog(buttons = gtk.BUTTONS_OK, 
				message_format = koduj(komunikat))
	message_dialog.run()
	message_dialog.destroy()
			

def drukuj_dokument_clicked(button, xml):
	dokument_tree = xml.get_widget('dokumenty_tree')
	model, iter = dokument_tree.get_selection().get_selected()
	dokument = model.get_value(iter, 0)
	nazwa = pobierz_nazwe_pliku()
	# Jeli wybrano katalog - anuluj lub pusty wybr - to pomijamy
	if not os.path.isdir(nazwa):
		liczba = API.drukuj_dokument(dokument, nazwa)
		wyswietl_komunikat('Wydrukowano stron: %s.' % liczba)
	else:
		wyswietl_komunikat('Nie wybrano nazwy pliku, anuluj drukowanie.')
		


def wybrano_dokument(selection, xml):
	model, iter = selection.get_selected()
	if iter:
		edytuj = xml.get_widget('edytuj_button')
		edytuj.set_sensitive(1)
		drukuj = xml.get_widget('drukuj_button')
		drukuj.set_sensitive(1)
	
def wybor_dokumentu(selection, xml):
	rodzaj_tree = xml.get_widget('rodzaj_dokumentu_tree')
	model, iter = rodzaj_tree.get_selection().get_selected()
	
	dokument_tree = xml.get_widget('dokumenty_tree')
	usun_kolumny(dokument_tree)
	
	edytuj = xml.get_widget('edytuj_button')
	edytuj.set_sensitive(0)

	drukuj = xml.get_widget('drukuj_button')
	drukuj.set_sensitive(0)

	if iter:
		nazwa = model.get_value(iter, 0)		

		if nazwa in opis_dokumentu:
			opis = opis_dokumentu[nazwa]
		else:
			opis = []
			
		if opis:
			arg = map(lambda a: a[2], opis)
			# Tu przechowuje odniesienie do dokumentu
			arg.insert(0, gobject.TYPE_PYOBJECT)
			model2 = gtk.ListStore(*arg)
			dokument_tree.set_model(model2)
			renderer2 = gtk.CellRendererText()
			i = 1
			for kolumna in opis:
				column2 = gtk.TreeViewColumn(koduj(kolumna[1]), renderer2, text=i)
				dokument_tree.append_column(column2)
				i = i + 1
			i = 0
			for dok in model.get_value(iter, 3):
				dodaj_dokument(dokument_tree, opis, dok, i)
				i = i + 1


def usun_kolumny(tree):
	tree.set_model()
	kolumna = tree.get_column(0)
	while kolumna:
		tree.remove_column(kolumna)
		kolumna = tree.get_column(0)


def wypelnij_podzestawy(zestaw, xml):
	rodzaj_tree = xml.get_widget('rodzaj_dokumentu_tree')
	usun_kolumny(rodzaj_tree)
	model = gtk.TreeStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
	rodzaj_tree.set_model(model)
	renderer = gtk.CellRendererText()
	column = gtk.TreeViewColumn(koduj('Rodzaj dokumentu'), renderer, text=1)
	rodzaj_tree.append_column(column)
	column = gtk.TreeViewColumn(koduj('Liczba'), renderer, text=2)
	rodzaj_tree.append_column(column)
	iter = model.append(None)
	model.set_value(iter, 0, '')
	model.set_value(iter, 1, koduj(API.nazwa_zestawu(zestaw)))
	model.set_value(iter, 2, koduj(''))
	model.set_value(iter, 3, '')
	dodaj_dzieci(rodzaj_tree, iter, zestaw, '')
	selection = rodzaj_tree.get_selection()
	selection.connect('changed', wybor_dokumentu, xml)

	dokument_tree = xml.get_widget('dokumenty_tree')
	usun_kolumny(dokument_tree)
	selection = dokument_tree.get_selection()
	selection.connect('changed', wybrano_dokument, xml)

	edytuj = xml.get_widget('edytuj_button')
	edytuj.set_sensitive(0)

	drukuj = xml.get_widget('drukuj_button')
	drukuj.set_sensitive(0)

	

def zestaw_button_clicked(button, xml):
	zestaw = wybierz_platnika_i_zestaw()
	if zestaw:
		notebook = xml.get_widget('notebook1')
		notebook.set_current_page(2)
		wypelnij_podzestawy(zestaw[0], xml)

def zakoncz_wszystko(button, window):
	window.destroy()

def wylacz(xml, nazwa):
	widget = xml.get_widget(koduj(nazwa))
	widget.set_sensitive(0)

def go():
	plik = os.path.join('gui/glade2', 'main.glade')
	okno = 'janosik_okno'
	xml = wczytaj_okno(plik, okno)
	
	window = xml.get_widget(okno)
	window.connect('destroy', gtk.mainquit)

	zakoncz_przycisk = xml.get_widget('zakoncz_button')
	zakoncz_przycisk.connect('clicked', zakoncz_wszystko, window)
	
	zakoncz_menu = xml.get_widget('zakoncz_menu')
	zakoncz_menu.connect('activate', zakoncz_wszystko, window)

	zestaw_button = xml.get_widget('zestaw_button')
	zestaw_button.connect('clicked', zestaw_button_clicked, xml)

	edytuj = xml.get_widget('edytuj_button')
	edytuj.set_sensitive(0)
	edytuj.connect('clicked', edytuj_dokument_clicked, xml) 

	drukuj = xml.get_widget('drukuj_button')
	drukuj.set_sensitive(0)
	drukuj.connect('clicked', drukuj_dokument_clicked, xml) 

	notebook = xml.get_widget('notebook1')
	notebook.set_show_tabs(0)

	# Nie obsugiwane przyciski w taskbarze
	wylacz(xml, 'pomoc_button')
	wylacz(xml, 'preferencje_button')
	wylacz(xml, 'usun_button')
	wylacz(xml, 'wlasciwosci_button')
	wylacz(xml, 'rejestr_button')

	# Nie obsugiwane elementy w menu
	wylacz(xml, 'pomoc1')
	wylacz(xml, 'zestaw1')
	wylacz(xml, 'widok1')
	wylacz(xml, 'narzdzia1')
	wylacz(xml, 'patnik1')
	wylacz(xml, 'ustawienia_wydruku1')
	wylacz(xml, 'opcje1')

	gtk.mainloop()
	
